/*
CLABv3 Sketch Compact Red Needle for Rasperry Pi Picos
H. Berndt 2023, Arduino IDE 2.0.4
http://www.hjberndt.de/soft/compactRN.html
Digitale Ausgänge 0,1,2,3,4,5,6,7 an Pin 1,2,4,5,6,7,9,10
Digitale Eingänge 0,1,2,3,4,5,6,7 an Pin 11,12,14,15,16,17,18,20
Eingang A/B Pin 31/32
PWM Pin 1
*/

#define AIN1 60
#define AIN2 58
#define DIN 211
#define DOUT 81
#define PWM 64
#define PWMPIN 0

byte Douts[] = {0,1,2,3,4,5,6,7};//PICO DIGITAL OUT PINS 0 - 7 CLAB
byte Dins[]  = { 8,9,10,11,12,13,14,15 }; //PICO //DIGITAL IN  PINS 0 - 7 CLAB
byte Bits[]  = {1,2,4,8,16,32,64,128};//BitValues
//ANALOG A0 A1

void setup()
{ Serial.begin(9600); //Special CLAB
  for(int i= 0;i<8;i++)pinMode(Douts[i],OUTPUT);
  for(int i= 0;i<8;i++)pinMode(Dins [i],INPUT);// OPEN LOW
}

void loop()
{ int i, val, inbyte; byte b;
  val = Serial.available(); //Was da?
  if (val>0)
  {inbyte=Serial.read(); //abholen
   delay(5);
   switch(inbyte)
  { case 13  : //CLAB ID nur ab Compact 1.75!
               Serial.write(3);delay(2);break; //ID
    case PWM:  b=Serial.read(); //Ausgabebyte holen
               analogWrite(PWMPIN,b);
               break;
    case DIN : for(i=0,b=0;i<8;i++) //PINS to BYTE
                b+= (digitalRead(Dins[i])==HIGH?Bits[i]:0);
               Serial.write(b);break; 
    case AIN1: 
    case 48:   Serial.write(analogRead(A0)>>2);break;
    case AIN2: 
    case 49:   Serial.write(analogRead(A1)>>2);break;
    case DOUT: b=Serial.read(); //Ausgabebyte holen
               for(i=0;i<8;i++)
                digitalWrite(Douts[i],b&Bits[i]?HIGH:LOW);
               break;
    default:   break;
  }
 }
 delay(10);
}
